blob: ad05dcb2c153315ac6f84433c2d4e250e83790c6 [file] [log] [blame]
Denis Vlasenkoab9eef22007-03-07 22:02:23 +00001#!/bin/sh
2
Ron Yorstonecaec1d2018-02-09 09:01:19 +00003test -f "$bindir/.config" && . "$bindir/.config"
4
Denys Vlasenkoc0e37b42011-10-31 01:08:35 +01005FAILCOUNT=0
Dan Fandrich140ac912010-08-29 04:47:03 +02006
Denys Vlasenkoc0e37b42011-10-31 01:08:35 +01007bb="busybox "
Denis Vlasenkoab9eef22007-03-07 22:02:23 +00008
Denys Vlasenkoc0e37b42011-10-31 01:08:35 +01009unset LC_ALL
10unset LC_MESSAGES
11unset LANG
12unset LANGUAGE
Denis Vlasenkoab9eef22007-03-07 22:02:23 +000013
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +020014hello_Z() {
15 # Compressed "HELLO\n"
16 $ECHO -ne "\x1f\x9d\x90\x48\x8a\x30\x61\xf2\x44\x01"
17}
18
Denys Vlasenkoc0e37b42011-10-31 01:08:35 +010019hello_gz() {
20 # Gzipped "HELLO\n"
21 #_________________________ vvv vvv vvv vvv - mtime
22 $ECHO -ne "\x1f\x8b\x08\x00\x85\x1d\xef\x45\x02\x03\xf3\x70\xf5\xf1\xf1\xe7"
23 $ECHO -ne "\x02\x00\x6e\xd7\xac\xfd\x06\x00\x00\x00"
24}
25
26hello_bz2() {
27 # Bzipped "HELLO\n"
28 $ECHO -ne "\x42\x5a\x68\x39\x31\x41\x59\x26\x53\x59\x5b\xb8\xe8\xa3\x00\x00"
29 $ECHO -ne "\x01\x44\x00\x00\x10\x02\x44\xa0\x00\x30\xcd\x00\xc3\x46\x29\x97"
30 $ECHO -ne "\x17\x72\x45\x38\x50\x90\x5b\xb8\xe8\xa3"
31}
32
Denys Vlasenko94593792018-06-27 13:15:10 +020033test x"$CONFIG_ZCAT" = x"y" && \
Denys Vlasenko69c8c692015-10-11 16:27:55 +020034for ext in \
Denys Vlasenko94593792018-06-27 13:15:10 +020035 `test x"$CONFIG_FEATURE_SEAMLESS_GZ" = x"y" && echo gz` \
36 `test x"$CONFIG_FEATURE_SEAMLESS_BZ2" = x"y" && echo bz2` \
37 `test x"$CONFIG_FEATURE_SEAMLESS_Z" = x"y" && echo Z`
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +020038do
39 prep() {
40 rm -f t1.$ext t2.$ext t_actual
41 hello_$ext >t1.$ext
42 hello_$ext >t2.$ext
43 }
Denys Vlasenkoc0e37b42011-10-31 01:08:35 +010044
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +020045 check() {
46 eval $2 >t_actual 2>&1
47 if $ECHO -ne "$expected" | cmp - t_actual; then
48 echo "PASS: $1"
49 else
50 echo "FAIL: $1"
Denys Vlasenkoa429d5d2018-06-27 10:35:45 +020051 #echo "t_actual:"
52 #cat t_actual
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +020053 FAILCOUNT=$((FAILCOUNT + 1))
54 fi
55 }
Denys Vlasenkoc0e37b42011-10-31 01:08:35 +010056
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +020057 mkdir testdir 2>/dev/null
58 (
59 cd testdir || { echo "cannot cd testdir!"; exit 1; }
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +020060 expected="HELLO\nok\n"
Denys Vlasenko69c8c692015-10-11 16:27:55 +020061 prep
62 check "zcat: dont delete $ext src" "${bb}zcat t2.$ext; test -f t2.$ext && echo ok"
63 exit $FAILCOUNT
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +020064 )
Denys Vlasenko69c8c692015-10-11 16:27:55 +020065 FAILCOUNT=$?
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +020066 rm -rf testdir
67done
Denys Vlasenkobcdae632011-10-31 01:10:47 +010068
69
70# Copyright 2011 by Denys Vlasenko
71# Licensed under GPLv2, see file LICENSE in this source tree.
72
73. ./testing.sh
74
75# testing "test name" "command" "expected result" "file input" "stdin"
76
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +020077## bzip algorithm
78
Denys Vlasenkobcdae632011-10-31 01:10:47 +010079# "input" file is bzipped file with "a\n" data
80testing "bzcat can print many files" \
Ron Yorstonecaec1d2018-02-09 09:01:19 +000081"bzcat input input; echo \$?" \
Denys Vlasenkobcdae632011-10-31 01:10:47 +010082"\
83a
84a
850
86" "\
87\x42\x5a\x68\x39\x31\x41\x59\x26\x53\x59\x63\x3e\xd6\xe2\x00\x00\
88\x00\xc1\x00\x00\x10\x20\x00\x20\x00\x21\x00\x82\xb1\x77\x24\x53\
89\x85\x09\x06\x33\xed\x6e\x20\
90" ""
91
92# "input" file is bzipped zero byte file
93testing "bzcat can handle compressed zero-length bzip2 files" \
Ron Yorstonecaec1d2018-02-09 09:01:19 +000094"bzcat input input; echo \$?" \
Denys Vlasenkobcdae632011-10-31 01:10:47 +010095"0\n" \
96"\x42\x5a\x68\x39\x17\x72\x45\x38\x50\x90\x00\x00\x00\x00" ""
97
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +020098## compress algorithm
99
100# "input" file is compressed (.Z) file with "a\n" data
Denys Vlasenko94593792018-06-27 13:15:10 +0200101test x"$CONFIG_ZCAT" = x"y" && \
Denys Vlasenkoa429d5d2018-06-27 10:35:45 +0200102test x"$CONFIG_FEATURE_SEAMLESS_Z" = x"y" && \
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +0200103testing "zcat can print many files" \
Ron Yorstonecaec1d2018-02-09 09:01:19 +0000104"zcat input input; echo \$?" \
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +0200105"\
106a
107a
1080
109" "\
110\x1f\x9d\x90\x61\x14\x00\
111" ""
112
113# "input" file is compressed (.Z) zero byte file
Denys Vlasenko94593792018-06-27 13:15:10 +0200114test x"$CONFIG_ZCAT" = x"y" && \
Denys Vlasenkoa429d5d2018-06-27 10:35:45 +0200115test x"$CONFIG_FEATURE_SEAMLESS_Z" = x"y" && \
Denys Vlasenko69c8c692015-10-11 16:27:55 +0200116testing "zcat can handle compressed zero-length (.Z) files" \
Ron Yorstonecaec1d2018-02-09 09:01:19 +0000117"zcat input input; echo \$?" \
Thiago Jung Bauermann17b16222015-05-11 17:18:59 +0200118"0\n" \
119"\x1f\x9d\x90\x00" ""
120
Denys Vlasenkobcdae632011-10-31 01:10:47 +0100121
122
Denys Vlasenkoc0e37b42011-10-31 01:08:35 +0100123exit $((FAILCOUNT <= 255 ? FAILCOUNT : 255))